﻿Option Explicit On

Public Class frmMain


    ' ========================================================================
    '   ◆Win32API : SendMessage
    ' ========================================================================
    <System.Runtime.InteropServices.DllImport("User32.dll")> _
    Shared Function SendMessage(ByVal hWnd As IntPtr, ByVal msg As Integer, ByVal wParam As Integer, ByVal lParam() As Integer) As IntPtr
    End Function


    ' ========================================================================
    '   ◆グローバル変数 : 設定が変更されたよフラグ
    ' ========================================================================
    Dim d_IsSettingChange As Boolean = False


    ' ========================================================================
    '   ◆グローバル変数 ： 設定データ
    ' ========================================================================
    Dim d_mySetting As MYSETTING



    Private Sub TabPageBrowser_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TabPageBrowser.Enter
        ' ========================================================
        '   とりあえずブランク表示
        ' ========================================================
        ViewBrowser.Navigate("about:blank")
        Application.DoEvents()

        ' ========================================================
        '   ソースをHTMLにコンバートします
        ' ========================================================
        Dim myString As String = ConvertSourceToHtml(txtCodePaste.Text, d_mySetting.TabWidth, d_mySetting.IsWriteLineNo, d_mySetting.XmlKeyWord)

        ' ========================================================
        '   ヘッダを記述
        ' ========================================================
        Dim myHeader As String = "<!DOCTYPE html PUBLIC ""-//W3C//DTD XHTML 1.0 Strict//EN"" ""http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"">" + vbCrLf + _
        "<html xmlns=""http://www.w3.org/1999/xhtml"" xml:lang=""ja"" lang=""ja"" dir=""ltr"">" + vbCrLf

        ' ========================================================
        '   スタイルシートを抽出
        ' ========================================================
        Dim myStyleSheet As String = "<HEAD><style type=""text/css""> " + vbCrLf + txtCssEdit.Text + "</style></HEAD>" + vbCrLf + vbCrLf


        ' ========================================================
        '   ブラウザに出力
        ' ========================================================
        ViewBrowser.Document.OpenNew(False).Write(myHeader + myStyleSheet + "<BODY>" + myString + "</BODY></HTML>")
    End Sub




    Private Sub TabPageHTML_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabPageHTML.Enter
        ' ========================================================
        '   ソースをHTMLにコンバートします
        ' ========================================================
        Dim myString As String = ConvertSourceToHtml(txtCodePaste.Text, d_mySetting.TabWidth, d_mySetting.IsWriteLineNo, d_mySetting.XmlKeyWord)

        ' ========================================================
        '   改行を削除します
        ' ========================================================
        myString = myString.Replace(vbCrLf, "")

        ' ========================================================
        '   <pre>タグをWeb Dialy Professionalの本文装飾タグに置換します
        ' ========================================================
        myString = myString.Replace("<pre>", ">|" + vbCrLf)
        myString = myString.Replace("</pre>", vbCrLf + "|<")

        ' ========================================================
        '   HTML出力テキストボックスに表示
        ' ========================================================
        txtHtmlOutput.Text = myString
    End Sub



    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ========================================================
        '   XMLから設定データを読み込みます
        ' ========================================================
        d_mySetting = LoadSettingInfo("setting.xml")

        ' ========================================================
        '   読み込んだ設定データを反映します
        ' ========================================================
        txtCssEdit.Text = d_mySetting.CssText
        txtCodePaste.Text = d_mySetting.SourceCode
        txtTabWidth.Text = d_mySetting.TabWidth.ToString

        ' ========================================================
        '   テキストボックスの[TAB]幅を設定します
        ' ========================================================
        txtTabWidth_LostFocus(sender, Nothing)

    End Sub
    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' ========================================================
        '   全てのテキストボックスがフォーカスを失ったことにする
        ' ========================================================
        txtCodePaste_LostFocus(sender, Nothing)
        txtCssEdit_LostFocus(sender, Nothing)
        txtTabWidth_LostFocus(sender, Nothing)


        ' ========================================================
        '   タブサイズの異常判定
        ' ========================================================
        If d_IsSettingChange Then
            If MessageBox.Show("設定を保存しますか？", "保存", MessageBoxButtons.YesNo, MessageBoxIcon.Information) = Windows.Forms.DialogResult.Yes Then
                SaveSettingInfo(d_mySetting, "Setting.xml")
            End If
        End If
    End Sub


    ' ========================================================
    '   テキストボックスのキー押下イベント処理
    ' ========================================================
    Private Sub txtCodePaste_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtCodePaste.KeyDown
        TextBox_KeyDown(CType(sender, TextBox), e)
    End Sub
    Private Sub txtHtmlOutput_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtHtmlOutput.KeyDown
        TextBox_KeyDown(CType(sender, TextBox), e)
    End Sub
    Private Sub txtCssEdit_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtCssEdit.KeyDown
        TextBox_KeyDown(CType(sender, TextBox), e)
    End Sub
    Private Sub TextBox_KeyDown(ByVal sender As TextBox, ByVal e As System.Windows.Forms.KeyEventArgs)
        ' ========================================================
        '   [CTRL] + [A] で全選択を行います
        ' ========================================================
        If e.Control Then
            If e.KeyCode = Keys.A Then
                sender.SelectAll()
            End If
        End If
    End Sub



    Private Sub txtCodePaste_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtCodePaste.LostFocus
        ' ========================================================
        '   テキスト内容が変更されているなら保存します
        ' ========================================================
        If d_mySetting.SourceCode <> txtCodePaste.Text Then
            d_mySetting.SourceCode = txtCodePaste.Text
            d_IsSettingChange = True
        End If
    End Sub


    Private Sub txtCssEdit_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtCssEdit.LostFocus
        ' ========================================================
        '   テキスト内容が変更されているなら保存します
        ' ========================================================
        If d_mySetting.CssText <> txtCssEdit.Text Then
            d_IsSettingChange = True
            d_mySetting.CssText = txtCssEdit.Text
        End If
    End Sub

    Private Sub txtTabWidth_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtTabWidth.LostFocus
        ' ========================================================
        '   タブサイズが変更されているなら保存します
        ' ========================================================
        If Not Integer.TryParse(txtTabWidth.Text, d_mySetting.TabWidth) Then
            MessageBox.Show("タブサイズが異常です。再設定してください。", "警告", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        ' ========================================================
        '   テキストボックスの[TAB]幅を再設定します
        ' ========================================================
        Const EM_SETTABSTOPS As Integer = &HCB
        SendMessage(txtHtmlOutput.Handle, EM_SETTABSTOPS, 1, New Integer() {d_mySetting.TabWidth * 4})
        SendMessage(txtCssEdit.Handle, EM_SETTABSTOPS, 1, New Integer() {d_mySetting.TabWidth * 4})
        SendMessage(txtCodePaste.Handle, EM_SETTABSTOPS, 1, New Integer() {d_mySetting.TabWidth * 4})
    End Sub


    Private Sub txtTabWidth_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtTabWidth.KeyPress
        ' ========================================================
        '   0-9, Back Space以外拒否
        ' ========================================================
        If (e.KeyChar < "0"c Or e.KeyChar > "9"c) Then
            If e.KeyChar <> Microsoft.VisualBasic.ControlChars.Back Then
                e.Handled = True
                Return
            End If
        End If

        ' ========================================================
        '   設定データ変更されました
        ' ========================================================
        d_IsSettingChange = True
    End Sub


    Private Sub btnKeyCustom_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnKeyCustom.Click
        Dim myXmlDoc As System.Xml.XmlDocument = New System.Xml.XmlDocument

        ' ========================================================
        '   ダイアログを表示してキーワードの編集を行います
        ' ========================================================
        Try
            ' ====== 編集されたキーワードXMLをインポートします
            d_mySetting.XmlKeyWord = myXmlDoc.ImportNode(DlgKeyWord.ShowKeyEdit(d_mySetting.XmlKeyWord, Me), True)
            d_IsSettingChange = True
        Catch ex As Exception
        End Try

    End Sub

    Private Sub chkWriteLineNo_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkWriteLineNo.CheckedChanged
        d_mySetting.IsWriteLineNo = chkWriteLineNo.Checked
        d_IsSettingChange = True
    End Sub

End Class
